#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include "util.h"
#include "config.h"

char *mbtk_strdup(const char *s)
{
	int l = strlen(s);
	char *o = malloc(l+1);
	memcpy(o, s, l+1);
	return o;
}

void mbtk_error(const char *fmt, ...)
{
	va_list ap;

	fprintf(stderr, "MBTK ERROR: ");
	va_start(ap, fmt);
	vfprintf(stderr, fmt, ap);
	va_end(ap);
}

void mbtk_warning(const char *fmt, ...)
{
	va_list ap;

	fprintf(stderr, "MBTK warning: ");
	va_start(ap, fmt);
	vfprintf(stderr, fmt, ap);
	va_end(ap);
}

#ifndef MBTK_HAVE_SNPRINTF
#include <stdarg.h>
#include <stdio.h>
/* Assumes the caller will never render strings longer than 1k */
int mbtk_snprintf_(char *dst, size_t size, const char *fmt, ...)
{
	char buff[1024];
	size_t l;
	va_list ap;
	
	va_start(ap, fmt);
	l = vsprintf(buff, fmt, ap);
	if (l >= 1024) {
		fprintf(stderr, "mbtk_snprintf_(): string too long\n");
		abort();
	}
	va_end(ap);

	if (size <= l)
		l = size-1;

	buff[l] = '\0';
	memcpy(dst, buff, l+1);
	return l;
}
#endif
