#ifndef LIBMBTK_UTIL_H
#define LIBMBTK_UTIL_H

/* API: generic utility/helper/portability functions */

#include <libmbtk/config.h>

/* c89-portable version of strdup() */
char *mbtk_strdup(const char *s);

/* Report an error to stderr, similar to fprintf(stderr, fmt, ...);
   can be used to set a breakpoint in debugger */
void mbtk_error(const char *fmt, ...);

/* Report a warning to stderr, similar to fprintf(stderr, fmt, ...);
   can be used to set a breakpoint in debugger */
void mbtk_warning(const char *fmt, ...);


#define MBTK_MAX(a, b) (((a) > (b)) ? (a) : (b))
#define MBTK_MIN(a, b) (((a) < (b)) ? (a) : (b))

/* mbtk_snprintf() is a portable wrapper around snprintf with a limitation:
   the caller needs to ensure fully rendered string will never be longer
   than 1k (independently of mbtk_snprintf()'s size argument) */
#ifdef MBTK_HAVE_SNPRINTF
#define mbtk_snprintf snprintf
#else
#define mbtk_snprintf mbtk_snprintf_
#endif

#endif
