#ifndef LIBMBTK_WIDGET_CANVAS_H
#define LIBMBTK_WIDGET_CANVAS_H

#include <libmbtk/widget.h>
#include <libmbtk/widget_inlines.h>

/* Subwindow in which the application can draw using the backend API; default
   handler is ev2cb. */
typedef struct mbtk_canvas_s mbtk_canvas_t;
struct mbtk_canvas_s {
	mbtk_widget_t w;
	mbtk_window_t *subwin;
	int (*minsize)(mbtk_canvas_t *c, long *mx, long *my);
	int (*draw)(mbtk_canvas_t *c, long x_offs, long y_offs, long w, long h);
};

mbtk_canvas_t *mbtk_canvas_new(mbtk_canvas_t *caller_alloced);
void mbtk_canvas_set_minsize_cb(mbtk_canvas_t *c, int (*minsize)(mbtk_canvas_t*, long*, long*));
void mbtk_canvas_set_draw_cb(mbtk_canvas_t *c, int (*draw)(mbtk_canvas_t*, long, long, long, long));

/* When the ev2cb handler is installed on the, "event" callbacks are triggered
   on event sunhandled by child widgets. This function binds that callback. */
void mbtk_canvas_callback_event(mbtk_canvas_t *c, mbtk_event_handled_t (*cb)(mbtk_widget_t *w, mbtk_kw_t id, mbtk_event_t *ev, void *user_data), void *user_data);

MBTK_WIDGET_INLINES(canvas)

#endif
