#ifndef LIBMBTK_WIDGET_RADIOBUTTON_H
#define LIBMBTK_WIDGET_RADIOBUTTON_H

#include <libmbtk/config.h>
#include <libmbtk/widget.h>
#include <libmbtk/widget_inlines.h>

/* Checkbox: has two states, in activated state includes a mark;
   can be clicked a mouse click release or enter release */
typedef struct mbtk_radiobutton_s {
	mbtk_widget_t w;
} mbtk_radiobutton_t;

/* Create a new radiobutton. Handler is set to hand_toggle. */
mbtk_radiobutton_t *mbtk_radiobutton_new(mbtk_radiobutton_t *caller_alloced);

/* Called after the release on a click on the radiobutton */
void mbtk_radiobutton_callback_toggle(mbtk_radiobutton_t *b, mbtk_event_handled_t (*cb)(mbtk_widget_t *w, mbtk_kw_t id, void *user_data), void *user_data);


MBTK_WIDGET_INLINES(radiobutton)

#endif
